/***************************************************************************
 *   Project TUPI: Magia 2D                                                *
 *   Project Contact: info@maefloresta.com                                 *
 *   Project Website: http://www.maefloresta.com                           *
 *   Project Leader: Gustav Gonzalez <info@maefloresta.com>                *
 *                                                                         *
 *   Developers:                                                           *
 *   2010:                                                                 *
 *    Gustavo Gonzalez / xtingray                                          *
 *                                                                         *
 *   KTooN's versions:                                                     * 
 *                                                                         *
 *   2006:                                                                 *
 *    David Cuadrado                                                       *
 *    Jorge Cuadrado                                                       *
 *   2003:                                                                 *
 *    Fernado Roldan                                                       *
 *    Simena Dinas                                                         *
 *                                                                         *
 *   Copyright (C) 2010 Gustav Gonzalez - http://www.maefloresta.com       *
 *   License:                                                              *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "tstackedmainwindow.h"

TStackedMainWindow::TStackedMainWindow(QWidget *parent) : TMainWindow(parent)
{
    m_stack = new QStackedWidget;
    setCentralWidget(m_stack);
    
    connect(this, SIGNAL(perspectiveChanged(int)), this, SLOT(setupPerspective(int)));
}

TStackedMainWindow::~TStackedMainWindow()
{
}

void TStackedMainWindow::addWidget(QWidget *widget, int perspective)
{
    if (m_widgets.contains(perspective)) 
        return;
    
    m_widgets.insert(perspective, widget);
    m_stack->addWidget(widget);
}

void TStackedMainWindow::removeWidget(QWidget *widget)
{
    m_stack->removeWidget(widget);
    m_widgets.remove(m_widgets.key(widget));
}

void TStackedMainWindow::setupPerspective(int perspective)
{
    if (m_widgets.contains(perspective)) {
        QWidget *w = m_widgets[perspective];
        m_stack->setCurrentWidget(w);
    }
}
