/***************************************************************************
 *   Project TUPI: Magia 2D                                                *
 *   Project Contact: info@maefloresta.com                                 *
 *   Project Website: http://www.maefloresta.com                           *
 *   Project Leader: Gustav Gonzalez <info@maefloresta.com>                *
 *                                                                         *
 *   Developers:                                                           *
 *   2010:                                                                 *
 *    Gustavo Gonzalez / xtingray                                          *
 *                                                                         *
 *   KTooN's versions:                                                     * 
 *                                                                         *
 *   2006:                                                                 *
 *    David Cuadrado                                                       *
 *    Jorge Cuadrado                                                       *
 *   2003:                                                                 *
 *    Fernado Roldan                                                       *
 *    Simena Dinas                                                         *
 *                                                                         *
 *   Copyright (C) 2010 Gustav Gonzalez - http://www.maefloresta.com       *
 *   License:                                                              *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef TUPPROXYITEM_H
#define TUPPROXYITEM_H

#include "tglobal.h"

#include <QGraphicsItem>
#include <QGraphicsItemGroup>
#include <QPainter>

/**
 * @author David Cuadrado
*/

class TUPI_EXPORT TupProxyItem : public QGraphicsItem
{
    public:
        TupProxyItem(QGraphicsItem *item = 0);
        ~TupProxyItem();
        
        void setItem(QGraphicsItem *item);
        QGraphicsItem *item() const;
        
        virtual QRectF boundingRect() const;
        virtual void paint(QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget = 0);
        
        virtual bool collidesWithItem(const QGraphicsItem * other, Qt::ItemSelectionMode mode = Qt::IntersectsItemShape) const;
        virtual bool collidesWithPath(const QPainterPath & path, Qt::ItemSelectionMode mode = Qt::IntersectsItemShape) const;
        virtual bool contains(const QPointF & point) const;
        virtual bool isObscuredBy(const QGraphicsItem * item) const;
        virtual QPainterPath opaqueArea() const;
        
        QPainterPath shape () const;
        
        enum { Type = UserType + 2 };
        int type() const { return Type; }
        
    private:
        struct Private;
        Private *const k;
};

#endif


