/***************************************************************************
 *   Project TUPI: Magia 2D                                                *
 *   Project Contact: info@maefloresta.com                                 *
 *   Project Website: http://www.maefloresta.com                           *
 *   Project Leader: Gustav Gonzalez <info@maefloresta.com>                *
 *                                                                         *
 *   Developers:                                                           *
 *   2010:                                                                 *
 *    Gustavo Gonzalez / xtingray                                          *
 *                                                                         *
 *   KTooN's versions:                                                     * 
 *                                                                         *
 *   2006:                                                                 *
 *    David Cuadrado                                                       *
 *    Jorge Cuadrado                                                       *
 *   2003:                                                                 *
 *    Fernado Roldan                                                       *
 *    Simena Dinas                                                         *
 *                                                                         *
 *   Copyright (C) 2010 Gustav Gonzalez - http://www.maefloresta.com       *
 *   License:                                                              *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "tupackparser.h"

struct TupAckParser::Private
{
    QString sign;
};

TupAckParser::TupAckParser() : TupXmlParserBase(), k(new Private())
{
}

TupAckParser::~TupAckParser()
{
    delete k;
}

bool TupAckParser::startTag(const QString &tag, const QXmlAttributes &atts)
{
    Q_UNUSED(atts);

    if (root() == "server_ack") {
        if (tag == "sign")
            setReadText(true);
    }
    
    return true;
}

bool TupAckParser::endTag(const QString &)
{
    return true;
}

void TupAckParser::text(const QString &msg)
{
    if (currentTag() == "sign")
        k->sign = msg;
}

QString TupAckParser::sign() const
{
    return k->sign;
}
