/***************************************************************************
 *   Project TUPI: Magia 2D                                                *
 *   Project Contact: info@maefloresta.com                                 *
 *   Project Website: http://www.maefloresta.com                           *
 *   Project Leader: Gustav Gonzalez <info@maefloresta.com>                *
 *                                                                         *
 *   Developers:                                                           *
 *   2010:                                                                 *
 *    Gustavo Gonzalez / xtingray                                          *
 *                                                                         *
 *   KTooN's versions:                                                     * 
 *                                                                         *
 *   2006:                                                                 *
 *    David Cuadrado                                                       *
 *    Jorge Cuadrado                                                       *
 *   2003:                                                                 *
 *    Fernado Roldan                                                       *
 *    Simena Dinas                                                         *
 *                                                                         *
 *   Copyright (C) 2010 Gustav Gonzalez - http://www.maefloresta.com       *
 *   License:                                                              *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "tupnotificationparser.h"

TupNotificationParser::TupNotificationParser(): TupXmlParserBase()
{
}

TupNotificationParser::~TupNotificationParser()
{
}

bool TupNotificationParser::startTag(const QString &tag, const QXmlAttributes &atts)
{
    if (root() == "communication_notification") {
        if (tag == "message") {
            package.level = atts.value("level").toInt();
            package.code = atts.value("code").toInt();
            setReadText(true);
        }
    }

    return true;
}

bool TupNotificationParser::endTag(const QString &tag)
{
    Q_UNUSED(tag);
    return true;
}

void TupNotificationParser::text(const QString &text)
{
    if (currentTag() == "message")
        package.message = text;
}

TupNotificationParser::Notification TupNotificationParser::notification()
{
    return package;
}



